jQuery(document).ready(function ($) {
	
	var auditTable = "wo_sys_wo_config"
    // 工单列表逻辑
    var app = new Vue({
        el: '#app',
        data: {
            deptId: 0,
            addDeptId:0,
            cfgId:'',
            depts: [
                /*{value: 0, text: "请选择"},
                {value: 1, text: "好柿"},
                {value: 2, text: "心暖"},
                {value: 3, text: "电商"},
                {value: 4, text: "客服"}*/
            ],
            operateName: '新增',
            displayForm: false,
            displayAuditTrace: false,
            addWoType: '',
            woTypes: [
                {value: "default", text: "请选择"},
                {value: 'book', text: "预订工单"},
                {value: "revisit", text: "回访工单"},
                {value: "fee", text: "费率修改工单"},
                {value: 'as', text: "售后工单"},
                {value: 'sys', text: "系统工单"},
                {value: 'manual', text: "人工工单"}
            ],
            /*woTrueTypes: {
                "revisit": 1,
                "": 0
            },*/
            woTypeDB: {
                0: "",
                1: "revisit"
            },
            urgentLevels: [
                {value: 0, text: "请选择"},
                {value: 1, text: "非常紧急"},
                {value: 2, text: "紧急"},
                {value: 3, text: "一般"}
            ],
            addUrgentLevel:0,
            duringTimeHour: 2,
            duringTimeMin: 0,
            assignLimit: 20,
            remindTime: 5,
            sysCfgList: [],
            auditTraceList: [],
            sysCfgId: 0,
            auditDetails: []
        },
        mounted: function () {
            // 初始化加载工单列表
            var url = "/work/sysWoCfg/listAll";
            /*var data = JSON.stringify({
                "woType": "revisit"
            });*/
            $.ajax({
                url: url,
                dataType: "json",
                /*data: data,*/
                type: 'post',
                contentType: "application/json; charset=utf-8",
                success: function (res) {
                    if (res.data) {
                    	console.log(res.data);
                        app.sysCfgList = res.data;
                    }
                }
            });
            
            $.ajax({
            	url: "/work/sysWoCfg/dept",
            	dataType: "json",
            	type: 'post',
            	contentType: "application/json; charset=utf-8",
            	success: function (res) {
            		if (res.data) {
            			console.log(res.data);
            			app.depts = res.data;
            		}
            	}
            })
        },
        methods: {
            sysCfgDetail: function (sysCfg) {
            	console.log("sysCfgDetail");
                app.displayForm = true;
                app.displayAuditTrace = false;
                // 获取工单配置详情
                var data = JSON.stringify(
                    {
                        "id": sysCfg.id
                    }
                );
                var url = "/work/sysWoCfg/detail";
                $.ajax({
                    url: url,
                    dataType: "json",
                    data: data,
                    type: 'post',
                    contentType: "application/json; charset=utf-8",
                    success: function (res) {
                        console.log(res);
                        if (res.data) {
                            app.addWoType = res.data.woType;
                            app.addUrgentLevel = res.data.urgentLevel;
                            app.addDeptId = res.data.deptId;
                            var duringTime = res.data.duringTime;
                            if(duringTime % 60 != 0) {
                                app.duringTimeMin = duringTime % 60 ;
                            }
                            app.duringTimeHour = Math.floor(duringTime / 60);
                            app.assignLimit = parseInt(res.data.assignLimit);
                            app.remindTime = res.data.remindTime;
                            app.sysCfgId = res.data.id;
                            app.operateName = '编辑';
                        }

                    }
                });
            },
            querySysCfg: function () {
            	app.displayForm = false;
            	app.displayAuditTrace = false;
                console.log('querySysCfg: deptId:' + app.deptId + ", cfgId: " + app.cfgId);
                var url = "/work/sysWoCfg/listByCriteria?deptId=" + app.deptId + "&cfgId=" + app.cfgId;
                $.ajax({
                    url: url,
                    dataType: "json",
                    type: 'post',
                    contentType: "application/json; charset=utf-8",
                    success: function (res) {
                        console.log(res);
                        if (res.data) {
                        	console.log(res.data);
                            app.sysCfgList = res.data;
                        }

                    }
                });

            },
            queryAuditTrace: function (sysCfg) {
                console.log('queryAuditTrace: ' + sysCfg.id);
                app.displayAuditTrace = true;
                app.displayForm = false;
                var data = JSON.stringify(
            		{
            			"tableName": auditTable,
            			"fieldValue": sysCfg.id
            		}
                );
                var url = "/work/auditTrace/list";
                $.ajax({
                    url: url,
                    dataType: "json",
                    data: data,
                    type: 'post',
                    contentType: "application/json; charset=utf-8",
                    success: function (res) {
                        console.log(res);
                        app.auditDetails = res.data;
                    }
                });
            },
            addSysCfg: function () {
            	console.log('addSysCfg');
                app.displayForm = true;
                app.displayAuditTrace = false;
                app.operateName = '新增';
                app.addDeptId = 0;
                app.addWoType = 'default';
                app.addUrgentLevel = 0;
                app.duringTimeHour = 0;
                app.duringTimeMin  = 0;
                app.remindTime = 5;
                app.assignLimit = 20;

            },
            saveOrUpdateSysCfg: function () {
                
                if(app.operateName == '新增'){
                	console.log('saveSysCfg');
                	console.log("Insert data...");
                	console.log(data);
                	var data = JSON.stringify(
                			{
                				"woType": app.addWoType,
                				"creator":1,//处理人id
                				"creatorName":'admin',//处理人名字
                				"deptId": app.addDeptId,
                				"deptName": app.depts.deptName,
                				"duringTime": parseInt(app.duringTimeMin) + parseInt(app.duringTimeHour * 60),
                				"remindTime": app.remindTime,
                				"assignLimit": parseInt(app.assignLimit),
                				"urgentLevel":app.addUrgentLevel
                			}
                	);
                	 var url = "/work/sysWoCfg/save";
                     $.ajax({
                         url: url,
                         dataType: "json",
                         data: data,
                         type: 'post',
                         contentType: "application/json; charset=utf-8",
                         success: function (res) {
                             console.log(res);
                             app.displayForm = false;
                             if(res.data.id = -1){
                            	 //TODO
                            	 this.messagebox.show("插入失败，已存在相同工单类型和归属部门的工单配置，请编辑实现");
                             }
                             $.ajax({
                            	 url: "/work/sysWoCfg/listAll",
                            	 dataType: "json",
                            	 type: 'post',
                            	 contentType: "application/json; charset=utf-8",
                            	 success: function (res) {
                            		 if (res.data) {
                            			 console.log(res.data);
                            			 app.sysCfgList = res.data;
                            		 }
                            	 }
                             });
                         }
                     });
                   //重新加載列表
                } else if(app.operateName == '编辑'){
                	console.log('updateSysCfg');
                	console.log("Update data...");
                	console.log(data);
                	var data = JSON.stringify(
                			{
                				"id": app.sysCfgId,
                				"woType": app.addWoType,
                				"creator":1,//处理人id
                				"creatorName":'admin',//处理人名字
                				"deptId": app.addDeptId,
                				"deptName": app.depts.deptName,
                				"duringTime": parseInt(app.duringTimeMin) + parseInt(app.duringTimeHour * 60),
                				"remindTime": app.remindTime,
                				"assignLimit": parseInt(app.assignLimit),
                				"urgentLevel":app.addUrgentLevel
                			}
                	);

                	var url = "/work/sysWoCfg/update";
                	$.ajax({
                		url: url,
                		dataType: "json",
                		data: data,
                		type: 'post',
                		contentType: "application/json; charset=utf-8",
                		success: function (res) {
                			console.log(res);
                			app.displayForm = false;
                			$.ajax({
                				url: "/work/sysWoCfg/listAll",
                				dataType: "json",
                				type: 'post',
                				contentType: "application/json; charset=utf-8",
                				success: function (res) {
                					if (res.data) {
                						console.log(res.data);
                						app.sysCfgList = res.data;
                					}
                				}
                			});
                		}
                	});
                	//重新加載列表
                }
                // app.displayForm = true;
            }
        }
    })

    function initLoadWoSysConfig() {


    }

    initLoadWoSysConfig();
});
